@echo off
chcp 65001
setlocal enableextensions EnableDelayedExpansion

REM Rclone backup to google drive

:Main

call :InitEnvironment
set customer=SXL
set hostname=hq-derekwin
set mailto=systems@sxl.net
set mailtoerror=systems@sxl.net
set dest=dc_drv
rem set dest=crypted

call :RcloneSync "C:\derek\FileToolbox"
call :RcloneZipMove "C:\derek\FileToolbox"

goto EOF
::call :RcloneZipMove "C:\derek\FileToolbox"

call :RcloneSync "C:\derek\FileToolbox"

goto EOF
::END of Main

REM *** STOP changing below unless you know what you are doing

:InitEnvironment
REM %~dp0 is the scripts path
cd /d %~dp0
set PATH=%PATH%;%~dp0\bin

REM Set TimeStamp
REM build the timestamp (need wmic)
for /f "tokens=2 delims==" %%a in ('wmic OS Get localdatetime /value') do set "dt=%%a"
set "YY=%dt:~2,2%" & set "YYYY=%dt:~0,4%" & set "MM=%dt:~4,2%" & set "DD=%dt:~6,2%"
set "HH=%dt:~8,2%" & set "Min=%dt:~10,2%" & set "Sec=%dt:~12,2%"
set "timestamp=%YYYY%%MM%%DD%-%HH%%Min%%Sec%"
echo Timestamp=%timestamp%
REM old way to build timestamp (for W2k, no wmic)
:: for mm/dd/yy region>> set timestamp=%date:~-4%%date:~4,2%%date:~7,2%_%time:~0,2%%time:~3,2%%time:~6,2%
:: for dd/mm/yy region>> set timestamp=%date:~-4%%date:~7,2%%date:~4,2%_%time:~0,2%%time:~3,2%%time:~6,2%
goto EOF


:RcloneSync
:: 
set src=%1
:: set %folder% to the last folder name
for %%f in (%src%) do set folder=%%~nxf
echo Folder=%folder%
set logfile=%TEMP%\rclone-%folder%-%timestamp%.log
echo logfile=%logfile%
set args=-v --bwlimit 8M --exclude-from rclone-exclude.txt

rclone sync %args% "%src%" "%dest%:\%customer%\%hostname%\%folder%\%folder%-current" ^
  --backup-dir "%dest%:\%customer%\%hostname%\%folder%\%folder%-%timestamp%" ^
  --log-file="%logfile%"
if %errorlevel% NEQ 0 (
  blat %logfile% -to %mailto% -cc "%mailtoerror%" -subject "Error rcbackup: %hostname% of %customer%"
) else (
  blat %logfile% -to %mailto% -subject "Success rcbackup: %hostname% of %customer%"
)
rclone move %logfile% "%dest%:\%customer%\%hostname%\%folder%\logs"
goto EOF


:RcloneZipMove
:: 7zip the %1 folder and move to rclone target
set src=%1
:: set %folder% to the last folder name
for %%f in (%src%) do set folder=%%~nxf
echo Folder=%folder%
set tempzip="%temp%\%folder%-%timestamp%.7z"
7za a -t7z -mx=3 -r %tempzip% "%src%"
set logfile=%TEMP%\rclone-%folder%-%timestamp%.log
rclone move -v %tempzip% "%dest%:\%customer%\%hostname%\zip\%folder%" --log-file="%logfile%"
if %errorlevel% NEQ 0 (
  blat %logfile% -to %mailto% -cc "%mailtoerror%" -subject "Error rcbackup: %hostname% of %customer%"
) else (
  blat %logfile% -to %mailto% -subject "Success rcbackup: %hostname% of %customer%"
)
rclone move %logfile% "%dest%:\%customer%\%hostname%\zip\%folder%\logs"
goto EOF


:EOF
REM End of file
