:: Author: Derek Chan
:: Purpose: Mount a rclone remote to a drive letter
:: Syntax: my-rclonemount <remotename-without-colon>
:: Requirement: Put rclone.exe, q-dir.exe in PATH
:: Revision 20180423: Initial Commit
@echo off
SETLOCAL ENABLEDELAYEDEXPANSION

if ["%~1"]==[""] (
  REM Syntax error. List the lines begin with ::
  type %0 | findstr /R /C:"^::"
  echo Existing rclone remotes:
  rclone listremotes
  exit /b 1
)


set REMOTE=%1
set PARAM= -vv --vfs-cache-max-age 10m --vfs-cache-mode minimal --no-modtime --allow-other

REM find next free drive letter (from Z to F)
for %%a in (F G H I J K L M N O P Q R S T U V W X Y Z) do (
  CD %%a: 1>> nul 2>&1
  if errorlevel 1 set DRIVE=%%a
)

echo Mounting %REMOTE% to %DRIVE%:
start "rclone_%REMOTE%" /min rclone.exe mount %REMOTE%: %DRIVE%: %PARAM%

echo wait a few seconds
ping localhost 1>>nul 2>&1

echo open Explorer
REM start explorer++.exe %DRIVE%:
REM q-dir.exe is faster in directory listing
start q-dir.exe %DRIVE%: c: e: \\hq-p2p

REM pause